/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// ServicesMysqlApiService ServicesMysqlApi service
type ServicesMysqlApiService service

type ApiAppAuthorizerMysqlMysqlAuthorizerActionTlsRequest struct {
	ctx        context.Context
	ApiService *ServicesMysqlApiService
}

func (r ApiAppAuthorizerMysqlMysqlAuthorizerActionTlsRequest) Execute() ([]LabelValueResponseInner, *http.Response, error) {
	return r.ApiService.AppAuthorizerMysqlMysqlAuthorizerActionTlsExecute(r)
}

/*
AppAuthorizerMysqlMysqlAuthorizerActionTls List of TLS options

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppAuthorizerMysqlMysqlAuthorizerActionTlsRequest
*/
func (a *ServicesMysqlApiService) AppAuthorizerMysqlMysqlAuthorizerActionTls(ctx context.Context) ApiAppAuthorizerMysqlMysqlAuthorizerActionTlsRequest {
	return ApiAppAuthorizerMysqlMysqlAuthorizerActionTlsRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []LabelValueResponseInner
func (a *ServicesMysqlApiService) AppAuthorizerMysqlMysqlAuthorizerActionTlsExecute(r ApiAppAuthorizerMysqlMysqlAuthorizerActionTlsRequest) ([]LabelValueResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodGet
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []LabelValueResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ServicesMysqlApiService.AppAuthorizerMysqlMysqlAuthorizerActionTls")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/services/mysql/actions/tls"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest struct {
	ctx                                                   context.Context
	ApiService                                            *ServicesMysqlApiService
	appAuthorizerMysqlMysqlAuthorizerCreateServiceRequest *AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest
}

//
func (r ApiAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest(appAuthorizerMysqlMysqlAuthorizerCreateServiceRequest AppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) ApiAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest {
	r.appAuthorizerMysqlMysqlAuthorizerCreateServiceRequest = &appAuthorizerMysqlMysqlAuthorizerCreateServiceRequest
	return r
}

func (r ApiAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) Execute() (*MysqlUserAuth, *http.Response, error) {
	return r.ApiService.AppAuthorizerMysqlMysqlAuthorizerCreateServiceExecute(r)
}

/*
AppAuthorizerMysqlMysqlAuthorizerCreateService Create service

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest
*/
func (a *ServicesMysqlApiService) AppAuthorizerMysqlMysqlAuthorizerCreateService(ctx context.Context) ApiAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest {
	return ApiAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return MysqlUserAuth
func (a *ServicesMysqlApiService) AppAuthorizerMysqlMysqlAuthorizerCreateServiceExecute(r ApiAppAuthorizerMysqlMysqlAuthorizerCreateServiceRequest) (*MysqlUserAuth, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *MysqlUserAuth
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ServicesMysqlApiService.AppAuthorizerMysqlMysqlAuthorizerCreateService")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/services/mysql"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.appAuthorizerMysqlMysqlAuthorizerCreateServiceRequest == nil {
		return localVarReturnValue, nil, reportError("appAuthorizerMysqlMysqlAuthorizerCreateServiceRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appAuthorizerMysqlMysqlAuthorizerCreateServiceRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
